using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Java.Lang;

namespace SilverCoins.Droid.Adapters
{
    class IconsAdapter : BaseAdapter
    {
        Context context;

        public IconsAdapter(Context _context)
        {
            context = _context;
        }

        public override int Count
        {
            get
            {
                return accountIcons.Length;
            }
        }

        public override Java.Lang.Object GetItem(int position)
        {
            return accountIcons[position];
        }

        public override long GetItemId(int position)
        {
            return accountIcons[position];
        }

        public override View GetView(int position, View convertView, ViewGroup parent)
        {
            ImageView imageView;

            if(convertView == null)
            {
                imageView = new ImageView(context);
                imageView.LayoutParameters = new GridView.LayoutParams(85, 85);
                imageView.SetScaleType(ImageView.ScaleType.CenterCrop);
                imageView.SetPadding(8, 8, 8, 8);
            }
            else
            {
                imageView = (ImageView)convertView;
            }
            // Sets the background for the first item that should be pre-selected.
            int iconPosition = GetPosition((int)parent.Tag);
            if (position == iconPosition)
                imageView.SetBackgroundResource(Resource.Color.accent);

            imageView.SetImageResource(accountIcons[position]);

            return imageView;
        }

        int[] accountIcons =
        {
            Resource.Drawable.ic_account_cash, Resource.Drawable.ic_account_visa,
            Resource.Drawable.ic_account_master, Resource.Drawable.ic_account_amex,
            Resource.Drawable.ic_account_euro, Resource.Drawable.ic_account_dollar
        };

        public int GetPosition(int iconId)
        {
            return Array.IndexOf(accountIcons, iconId);
        }
    }
}