﻿using SilverCoins.BusinessLayer.Managers;
using SilverCoins.BusinessLayer.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SilverCoins.Exporting
{
    public static class Export
    {
        public static List<TransactionExport> GetTransactionForExport(Account account, string type, DateTime from, DateTime to)
        {
            var transactionsExport = new List<TransactionExport>();
            var transactions = SilverCoinsManager.GetTransactions().Where(x => x.CreatedDate >= from && x.CreatedDate <= to).ToList();

            if (account.Id != 0)
            {
                transactions.Where(x => x.Account == account.Id).ToList();
            }

            if (type != "Both")
            {
                transactions.Where(x => x.Type == type).ToList();
            }

            foreach (var transaction in transactions)
            {
                var category = SilverCoinsManager.GetCategory(transaction.Category);
                var accountAc = SilverCoinsManager.GetAccount(transaction.Account);
                transactionsExport.Add(new TransactionExport
                {
                    Account = accountAc.Name,
                    Category = category.Name,
                    Type = transaction.Type,
                    Amount = transaction.Amount.ToString("N2"),
                    Currency = accountAc.Currency,
                    Date = transaction.CreatedDate.ToString("dd/MM/yyyy"),
                    PaymentType = transaction.PaymentType,
                    Name = transaction.Name
                });
            }

            return transactionsExport;
        }
    }
}
